/*
 * Written by Carsten Larsen.
 * Public domain.
 */

#include "config.h"

void err0(int eval, const char *text) {
    int errno2 = errno;
    fprintf(stderr, "%s: ", getprogname());

    if (text != NULL) {
        fprintf(stderr, "%s", text);
        fprintf(stderr, ": ");
    }

    fprintf(stderr, "%s\n", strerror(errno2));

    exit(eval);
}

void errx0(int eval, const char *text) {
    fprintf(stderr, "%s: ", getprogname());

    if (text != NULL)
        fprintf(stderr, "%s", text);

    fprintf(stderr, "\n");
    exit(eval);
}

void errx2(int eval, const char *fmt, const void *arg1, const void *arg2) {
    fprintf(stderr, "%s: ", getprogname());

    if (fmt != NULL)
        fprintf(stderr, fmt, arg1, arg2);

    fprintf(stderr, "\n");
    exit(eval);
}

void warn2(const char *fmt, const void *arg1, const void *arg2) {
    int errno2 = errno;
    fprintf(stderr, "%s: ", getprogname());

    if (fmt != NULL) {
        fprintf(stderr, fmt, arg1, arg2);
        fprintf(stderr, ": ");
    }

    fprintf(stderr, "%s\n", strerror(errno2));
}

void warnx0(const char *text) {
    fprintf(stderr, "%s: ", getprogname());

    if (text != NULL)
        fprintf(stderr, "%s", text);

    fprintf(stderr, "\n");
}

void warnx1(const char *fmt, const void *arg1)
{
    fprintf(stderr, "%s: ", getprogname());

    if (fmt != NULL)
        fprintf(stderr, fmt, arg1);

    fprintf(stderr, "\n");
}

void warnx2(const char *fmt, const void *arg1, const void *arg2) {
    fprintf(stderr, "%s: ", getprogname());

    if (fmt != NULL)
        fprintf(stderr, fmt, arg1, arg2);

    fprintf(stderr, "\n");
}
