/*
 * Written by Carsten Larsen.
 * Public domain.
 */

#ifndef WHOIS_VERSION_H
#define WHOIS_VERSION_H

#include "config.h"

#define PACKAGE_NAME      "whois"
#define PACKAGE_VERSION   "1.37"
#define PACKAGE_DATE      "28.11.2015"

#define EMPTYSTRING       ""
#define SPACE             " "

// -----------------------------------------------------
// --------- Processor architecture definitions --------
// -----------------------------------------------------

#ifdef mc68000
#define ACPU "68000+"
#endif

#ifdef mc68020
#ifdef ACPU
#undef ACPU
#endif
#define ACPU "68020"
#endif

#ifdef mc68030
#ifdef ACPU
#undef ACPU
#endif
#define ACPU "68030"
#endif

#ifdef mc68040
#ifdef ACPU
#undef ACPU
#endif
#define ACPU "68040"
#endif

#ifdef mc68060
#ifdef ACPU
#undef ACPU
#endif
#define ACPU "68060"
#endif

#if defined(INTELCPU)  || defined(i386)    || defined(i486)  ||  \
    defined(intel)     || defined(x86)     || defined(i86pc) ||  \
    defined(__i386__)  || defined(_M_IX86)
#ifdef ACPU
#undef ACPU
#endif
#define ACPU "i386"
#endif

#ifdef __powerpc__
#define ACPU "PowerPC"
#endif

#if defined(__x86_64__)
#ifdef ACPU
#undef ACPU
#endif
#define ACPU "amd64"
#endif

#ifdef WITHTEST
#define ATEST SPACE "TEST"
#else
#define ATEST EMPTYSTRING
#endif

#if defined(ACPU) && defined(__HAVE_68881__)
#define AFPU SPACE "FPU"
#else
#define AFPU EMPTYSTRING
#endif

#ifndef ACPU
#define ACPU EMPTYSTRING
#endif

// -----------------------------------------------------
// --------- Package version string definition ---------
// -----------------------------------------------------

#define PACKAGE_COMMENT ACPU AFPU

#define PACKAGE_VERSION_STRING \
        "\0$VER:" SPACE        \
        PACKAGE_NAME SPACE     \
        PACKAGE_VERSION SPACE  \
        PACKAGE_DATE SPACE     \
        PACKAGE_COMMENT

#endif
